/*************************************************************************/
/*    Copyright (C) 2020 Wizardry and Steamworks - License: GNU GPLv3    */
/*************************************************************************/
function wasKeyValueToObject(data) {
    var result = {};
    data.split('&').forEach((kvp) => {
        var kv = kvp.split('=')
            .filter((kv) => 
                kv[0] !== 'undefined' && kv[1] !== 'undefined'); 
        result[kv[0]] = kv[1];

    });
    return result;
}

/*************************************************************************/
/*    Copyright (C) 2017 Wizardry and Steamworks - License: GNU GPLv3    */
/*************************************************************************/
function wasKeyValueSet(k, v, data) {
    return data.split('&')
                .map(c => c.split('=')[0] === k ? `${k}=${v}` : c)
                .concat(`${k}=${v}`)
                .filter((e,i,s) => s.indexOf(e) === i)
                .join('&');
}


/*************************************************************************/
/*    Copyright (C) 2017 Wizardry and Steamworks - License: GNU GPLv3    */
/*************************************************************************/
function wasKeyValueGet(k, data) {
    return data.split('&').reduce((a, c) => {
        var s = c.split('=');
        return s[0] === k ? s[1] : a;
    }, '');
}